﻿using FluentValidation.AspNetCore;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Caching.Memory;
using Microsoft.Extensions.Options;
using Newtonsoft.Json.Linq;
using Performance.DtoModels;
using Performance.DtoModels.AppSettings;
using Performance.Infrastructure;
using Performance.Services;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Performance.Api.Controllers
{
    [Route("api/[controller]")]
    public class ComputeController : Controller
    {
        private ComputeService _computeService;
        private AllotService _allotService;
        public ComputeController(AllotService allotService,
            ComputeService computeService)
        {
            _allotService = allotService;
            _computeService = computeService;
        }

        [Route("deptdetail")]
        [HttpPost]
        public ApiResponse<DeptDetailResponse> DeptDetail([FromBody]DeptDetailRequest request)
        {
            var allot = _allotService.GetAllot(request.AllotId);
            if (null == allot)
                throw new PerformanceException("当前绩效记录不存在");

            DeptDetailResponse response = _computeService.GetDepartmentDetail(request);
            return new ApiResponse<DeptDetailResponse>(ResponseType.OK, response);
        }
    }
}